<?php

namespace NoccyLabs\PulseAudio;

use NoccyLabs\PulseAudio\Module\ModuleList;
use NoccyLabs\PulseAudio\Sink\SinkList;
use NoccyLabs\PulseAudio\Sink\SinkInputList;
use NoccyLabs\PulseAudio\Sink\NullSink;
use NoccyLabs\PulseAudio\Source\SourceList;
use NoccyLabs\PulseAudio\Source\SourceOutputList;
use NoccyLabs\PulseAudio\Client\ClientList;
use NoccyLabs\PulseAudio\Card\CardList;

class PulseAudio
{
    /**
     *
     *
     * @return ModuleList
     */
    public function getModules()
    {
        return new ModuleList($this);
    }

    public function getSinks()
    {
        return new SinkList($this);
    }

    public function createNullSink($name=null)
    {
        return new NullSink($this, $name);
    }

    public function getSinkByIndex($index)
    {
        $sinks = $this->getSinks();
        return $sinks[$index];
    }

    public function getSinkInputs()
    {
        return new SinkInputList($this);
    }

    public function getSources()
    {
        return new SourceList($this);
    }

    public function getSourceOutputs()
    {
        return new SourceOutputList($this);
    }

    public function getClients()
    {
        return new ClientList($this);
    }

    public function getClientByIndex($index)
    {
        $clients = $this->getClients();
        return $clients[$index];
    }

    public function getCards()
    {
        return new CardList($this);
    }

}

