<?php

namespace NoccyLabs\PulseAudio\Sink;

use NoccyLabs\PulseAudio\Helper\Pactl;
use NoccyLabs\PulseAudio\PulseAudio;
use NoccyLabs\PulseAudio\PropertyList;

class SinkInput
{
    
    protected $index;

    protected $sink;

    protected $client;

    protected $properties;

    protected $pulse;

    public function __construct(PulseAudio $pulse, $index, array $input=[])
    {
        $this->index = $index;
        $this->sink = $input['sink'];
        $this->client = $input['client'];
        $this->properties = new PropertyList($input['properties'], true);
    }

    public function getIndex()
    {
        return $this->index;
    }

    public function getSink()
    {
        return $this->sink;
    }

    public function getClient()
    {
        return $this->client;
    }

    public function getProperty($key)
    {
        return $this->properties[$key];
    }

    public function moveToSink(Sink $sink)
    {
        Pactl::call('move-sink-input', [ $this->index, $sink->getName() ]);
    }

}

